#include <stdio.h>
#include <stdlib.h>

typedef struct Person Person;
struct Person {
	char *name;
	int age;
	Person *best_friend;
};

Person *new_person(char *name, int age, Person *friend) {
	Person *p = (Person *) malloc(sizeof(Person));
	p->name = name;
	p->age = age;
	p->best_friend = friend;
	return p;
}

void print_person(Person *p) {
	printf("%s is %d years old. ", p->name, p->age);
	if(p->best_friend == NULL)
		printf("%s has no friends ☹.\n", p->name);
	else
		printf("%s's best friend is %s.\n", p->name, p->best_friend->name);
}

int main() {
	Person *lucy = new_person("Lucy", 21, NULL);
	print_person(lucy);
	Person *uli = new_person("Uli", 24, lucy);
	print_person(uli);
	lucy->best_friend = uli;
	print_person(lucy);
	free(lucy);
	free(uli);
	return 0;
}